class chain(object):
    """A dummy fallback implementation of chain iterator from
    itertools package (available for py2.3+)
    """

    def __init__(self, *iterables):
        self._iterables = iter(iterables)
        self._curseq = iter(list())

    def __iter__(self):
        return self

    def next(self):
        while True:
            try:
                return self._curseq.next()
            except StopIteration:
                pass

            self._curseq = iter(self._iterables.next())
        # endwhile
    # enddef next
# endclass chain
