import fileinput, re, grp, string


class ExInvalidConfigLine(Exception):
    def __init__(self, line):
        Exception.__init__(self)
        self.line = line

    def __str__(self):
        return "Invalid config line: " + self.line


instance = None


def get(key = None):
    global instance
    if not instance:
        instance = PleskConfig()

    if not key:
        return instance
    return instance[key]


class PleskConfig:
    __config = {}

    def __init__(self, configName = None):
        if configName == None:
            configName = "/etc/psa/psa.conf"
        self.__parse(configName)

    def __len__(self):
        return len(self.__config)

    def __getitem__(self, key):
        return self.__config[key]

    def __iter__(self):
        return self.iterkeys()

    def iterkeys(self):
        return self.__config.iterkeys()

    def iteritems(self):
        return self.__config.iteritems()

    def __parse(self, configFile):
        comment = re.compile('^\s*#')
        value = re.compile('^(\S+)\s+(.*)\n$')

        for line in fileinput.input(configFile):
            if line == '\n': continue
            if re.match(comment, line): continue
            data = re.match(value, line)
            if not data:
                raise ExInvalidConfigLine, line
            self.__config[data.group(1)] = string.rstrip(data.group(2))


def psaadm_gid():
    gr_gid = 2
    return grp.getgrnam("psaadm")[gr_gid]


# [a sort of] testsuite
if __name__ == '__main__':
    pc = PleskConfig()
    for i, v in pc.iteritems():
        print i + "->"+ v
